OGRE-Next: Ogre::v1::HardwareVertexBuffer Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::HardwareVertexBuffer Class Reference
Core » RenderSystem

Specialisation of HardwareBuffer for a vertex buffer. More...

`#include <OgreHardwareVertexBuffer.h>`

Inheritance diagram for Ogre::v1::HardwareVertexBuffer:
[legend]

## Public Member Functions
| HardwareVertexBuffer (HardwareBufferManagerBase *mgr, size_t vertexSize, size_t numVertices, HardwareBuffer::Usage usage, bool useSystemMemory, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwareVertexBuffer ()
size_t | getInstanceDataStepRate () const
| Get the number of instances to draw using the same per-instance data before advancing in the buffer by one element.
bool | getIsInstanceData () const
| Get if this vertex buffer is an "instance data" buffer (per instance).
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any.
size_t | getNumVertices () const
| Get the number of vertices in this buffer.
size_t | getVertexSize () const
| Gets the size in bytes of a single vertex in this buffer.
void | setInstanceDataStepRate (const size_t val)
| Set the number of instances to draw using the same per-instance data before advancing in the buffer by one element.
void | setIsInstanceData (const bool val)
| Set if this vertex buffer is an "instance data" buffer (per instance).
Public Member Functions inherited from Ogre::v1::HardwareBuffer
| HardwareBuffer (Usage usage, bool systemMemory, bool useShadowBuffer)
| Constructor, to be called by HardwareBufferManager only.
virtual | ~HardwareBuffer ()
virtual void | _updateFromShadow ()
| Updates the real buffer from the shadow buffer, if required.
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
virtual void * | getRenderSystemData ()
| An internal function that should be used only by a render system for internal use.
size_t | getSizeInBytes () const
| Returns the size of this buffer in bytes.
Usage | getUsage () const
| Returns the Usage flags with which this buffer was created.
bool | hasShadowBuffer () const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked () const
| Returns whether or not this buffer is currently locked.
bool | isSystemMemory () const
| Returns whether this buffer is held in system memory.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
virtual void | readData (size_t offset, size_t length, void *pDest)=0
| Reads data from the buffer and places it in the memory pointed to by pDest.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.
virtual void | unlock ()
| Releases the lock on this buffer.
virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)=0
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

## Additional Inherited Members
Public Types inherited from Ogre::v1::HardwareBuffer
enum | LockOptions { HBL_NORMAL , HBL_DISCARD , HBL_READ_ONLY , HBL_NO_OVERWRITE , HBL_WRITE_ONLY }
| Locking options. More...
enum | Usage { HBU_STATIC = 1 , HBU_DYNAMIC = 2 , HBU_WRITE_ONLY = 4 , HBU_DISCARDABLE = 8 , HBU_STATIC_WRITE_ONLY = 5 , HBU_DYNAMIC_WRITE_ONLY = 6 , HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...

## Detailed Description

Specialisation of HardwareBuffer for a vertex buffer.

The documentation for this class was generated from the following file:

- OgreHardwareVertexBuffer.h